com.saxonica.functions.xpath3

## Class Pi

- java.lang.Object
- - net.sf.saxon.lib.ExtensionFunctionDefinition
  - - com.saxonica.functions.xpath3.Pi

- All Implemented Interfaces:
    Serializable

      public class Pi
      extends ExtensionFunctionDefinition

  This class implements the function math:pi(), which is a standard function in XPath 3.0 and XQuery 3.0
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Pi()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `SequenceType[]` | `getArgumentTypes()` Get the required types for the arguments of this function.
    `StructuredQName` | `getFunctionQName()` Get the name of the function, as a QName.
    `int` | `getMaximumNumberOfArguments()` Get the maximum number of arguments allowed by the function.
    `int` | `getMinimumNumberOfArguments()` Get the minimum number of arguments required by the function
    `SequenceType` | `getResultType(SequenceType[] suppliedArgumentTypes)` Get the type of the result of the function
    `ExtensionFunctionCall` | `makeCallExpression()` Create a call on this function.
    `boolean` | `trustResultType()` Ask whether the result actually returned by the function can be trusted, or whether it should be checked against the declared type.

    - ### Methods inherited from class net.sf.saxon.lib.ExtensionFunctionDefinition

      `dependsOnFocus, hasSideEffects`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Pi

          public Pi()

  - ### Method Detail

    - #### getFunctionQName

          public StructuredQName getFunctionQName()

      Description copied from class: `ExtensionFunctionDefinition`
      Get the name of the function, as a QName.

      This method must be implemented in all subclasses

      Specified by:
        `getFunctionQName` in class `ExtensionFunctionDefinition`
      Returns:
        the function name

    - #### getMinimumNumberOfArguments

          public int getMinimumNumberOfArguments()

      Description copied from class: `ExtensionFunctionDefinition`
      Get the minimum number of arguments required by the function

      The default implementation returns the number of items in the result of calling `ExtensionFunctionDefinition.getArgumentTypes()`

      Overrides:
        `getMinimumNumberOfArguments` in class `ExtensionFunctionDefinition`
      Returns:
        the minimum number of arguments that must be supplied in a call to this function

    - #### getMaximumNumberOfArguments

          public int getMaximumNumberOfArguments()

      Description copied from class: `ExtensionFunctionDefinition`
      Get the maximum number of arguments allowed by the function.

      The default implementation returns the value of `ExtensionFunctionDefinition.getMinimumNumberOfArguments()`

      Overrides:
        `getMaximumNumberOfArguments` in class `ExtensionFunctionDefinition`
      Returns:
        the maximum number of arguments that may be supplied in a call to this function

    - #### trustResultType

          public boolean trustResultType()

      Description copied from class: `ExtensionFunctionDefinition`
      Ask whether the result actually returned by the function can be trusted, or whether it should be checked against the declared type.
      Overrides:
        `trustResultType` in class `ExtensionFunctionDefinition`
      Returns:
        true if the function implementation warrants that the value it returns will be an instance of the declared result type. The default value is false, in which case the result will be checked at run-time to ensure that it conforms to the declared type. If the value true is returned, but the function returns a value of the wrong type, the consequences are unpredictable.

    - #### getArgumentTypes

          public SequenceType[] getArgumentTypes()

      Description copied from class: `ExtensionFunctionDefinition`
      Get the required types for the arguments of this function.

      This method must be implemented in all subtypes.

      Specified by:
        `getArgumentTypes` in class `ExtensionFunctionDefinition`
      Returns:
        the required types of the arguments, as defined by the function signature. Normally this should be an array of size `ExtensionFunctionDefinition.getMaximumNumberOfArguments()`; however for functions that allow a variable number of arguments, the array can be smaller than this, with the last entry in the array providing the required type for all the remaining arguments.

    - #### getResultType

          public SequenceType getResultType(SequenceType[] suppliedArgumentTypes)

      Description copied from class: `ExtensionFunctionDefinition`
      Get the type of the result of the function

      This method must be implemented in all subtypes.

      Specified by:
        `getResultType` in class `ExtensionFunctionDefinition`
      Parameters:
        `suppliedArgumentTypes` - the static types of the supplied arguments to the function. This is provided so that a more precise result type can be returned in the common case where the type of the result depends on the types of the arguments.
      Returns:
        the return type of the function, as defined by its function signature

    - #### makeCallExpression

          public ExtensionFunctionCall makeCallExpression()

      Description copied from class: `ExtensionFunctionDefinition`
      Create a call on this function. This method is called by the compiler when it identifies a function call that calls this function.
      Specified by:
        `makeCallExpression` in class `ExtensionFunctionDefinition`
      Returns:
        an expression representing a call of this extension function

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.